
import pygame
from pygame.locals import *

import qgl
import qgle


def basic_screen(size):
    """
    Returns a root node with viewport and world children.
    """
    root_node = qgl.scene.Root()
    root_node.add(
        qgl.scene.PerspectiveViewport(
            qgl.scene.World()
        )
    )
    viewport = root_node[0]
    world = viewport[0]
    viewport.screen_dimensions = (0,0,size[0], size[1])
    viewport.aspect = float(size[0]) / size[1]
    return root_node, viewport, world

def main():
    pygame.init()
    flags =  OPENGL|DOUBLEBUF|HWSURFACE
    pygame.display.set_mode((800,600), flags)
    
    
    compiler = qgl.render.Compiler()
    render = qgl.render.Render()
    clock = pygame.time.Clock()
    root_node, viewport, world = basic_screen((800,600))
    
    points = (-1,-1,0),(-1,1,0),(1,1,0),(1,-1,0),(-1,-1,0)
    g1 = qgl.scene.Group(qgl.scene.state.Polyline(points))
    g1.translate = -2,0,0
    g2 = qgl.scene.Group(qgl.scene.state.Polyline(points))
    g2.translate = +2,0,0
    g3 = qgl.scene.Group(qgl.scene.state.Polyline(points))
    g3.translate = 2,1,0
    
    world.background.add(g1,g2, g3)
    root_node.accept(compiler)
    
    print qgle.collide((0,0,0),3, world.background)
    print qgle.collisions(world.background)
    return
    while True:
        for event in pygame.event.get():
            if event.type is QUIT:
                return
            elif event.type is KEYDOWN:
                print clock.get_fps()
                if event.key == 27: 
                    return
        
        root_node.accept(render)
        clock.tick()
        pygame.display.flip()
        
        
main()
