import random

import pygame
from pygame.locals import *

import qgl
import qgle


def basic_screen(size):
    """
    Returns a root node with viewport and world children.
    """
    root_node = qgl.scene.Root()
    root_node.add(
        qgl.scene.PerspectiveViewport(
            qgl.scene.World()
        )
    )
    viewport = root_node[0]
    world = viewport[0]
    viewport.screen_dimensions = (0,0,size[0], size[1])
    viewport.aspect = float(size[0]) / size[1]
    return root_node, viewport, world
    

def main():
    pygame.init()
    flags =  OPENGL|DOUBLEBUF|HWSURFACE
    pygame.display.set_mode((800,600), flags)
    
    
    compiler = qgl.render.Compiler()
    render = qgl.render.Render()
    clock = pygame.time.Clock()
    root_node, viewport, world = basic_screen((800,600))
    render_func = qgl.render.render
    
    clouds = qgl.scene.Group()
    world.background.add(qgl.scene.state.Light(position=(0,0,10)))
    clouds.add(qgl.scene.state.Texture("cloud.png"))
    for i in xrange(1000):
        g = qgl.scene.Group()
        #g.add(qgl.scene.Sphere(1.16,16))
        g.add(qgl.scene.state.Quad((1,1)))
        #g.leaves[0].texture_coords = tuple(g.leaves[0].texture_coords)
        g.translate = random.uniform(-20,20),random.uniform(-20,20),random.uniform(-20,20)
        clouds.add(g)
        
    
    world.background.add(clouds)
    root_node.accept(compiler)
    world.background.translate = (0,0,-40)
    clouds.axis = (0,1,0)
    cull_radius = 20
    while True:
        qgle.cull(clouds, cull_radius)
        for event in pygame.event.get():
            if event.type is QUIT:
                return
            elif event.type is KEYDOWN:
                print clock.get_fps()
                cull_radius -= 1
                if event.key == 27: 
                    return
        clouds.angle += 1
        root_node.accept(render)
                
        clock.tick()
        pygame.display.flip()


main()
#import profile
#profile.run("main()")

