
import pygame
from pygame.locals import *

import qgl



def main():
    pygame.init()
    flags =  OPENGL|DOUBLEBUF|HWSURFACE
    pygame.display.set_mode((800,600), flags)
    
    compiler = qgl.render.Compiler()
    render = qgl.render.Render()
    picker = qgl.render.Picker()
    clock = pygame.time.Clock()
    
    
    root_node = qgl.scene.Root()
    root_node.add(
        qgl.scene.PerspectiveViewport(
            qgl.scene.World()
        )
    )
    v = root_node[0]
    w = v[0]
    
    v.screen_dimensions = (0,0,800,600)
    v.aspect = 320.0 / 240.0
    
    #g = qgl.scene.Group()
    #g.add(qgl.scene.Texture("blue.jpg"))
    #g.add(qgl.scene.Quad((50,50)))
    #w.sky.add(g)
    #g = qgl.scene.Group()
    #g.add(qgl.scene.Texture("land.jpg"))
    #g.add(qgl.scene.Quad((50,50)))
    z = -5.0
    for i in xrange(500):
        ng = qgl.scene.Group()
        ng.add(qgl.scene.state.Texture("land.jpg"))
        ng.add(qgl.scene.state.Quad((1,1)))
        ng.translate = (0.0,100.0,z)
        z += 0.1
        w.ground.add(ng)
    print len(w.ground.branches)
    #gr = g.leaves[1]
    #w.ground.add(g)
    g = qgl.scene.Group()
    g.add(qgl.scene.state.Text("background", "mono.ttf"))
    w.background.add(g)
    g = qgl.scene.Group()
    g.add(qgl.scene.state.Text("foreground", "mono.ttf"))
    #g.add(qgl.scene.Explosion(1000))
    w.foreground.add(g)
    
    root_node.accept(compiler)
    #g.leaves[0].set_force(0,360,1)
    z = 0.0
    
    while True:
        #g.leaves[0].text = 'Simon'
        #g.leaves[0].apply_force(0.01)
        #gr.texture_coords += (0.0, 0.01)
        #w.camera.translate = (0.0,0.0,z)
        #z += 0.1
        for event in pygame.event.get():
            if event.type is QUIT:
                return
            elif event.type is KEYDOWN:
                print clock.get_fps()
                
            elif event.type is MOUSEBUTTONDOWN:
                picker.set_position(event.pos)
                root_node.accept(picker)
                for hit in picker.hits:
                    hit.parent.angle += 10
        root_node.accept(render)
        #qgl.accel.interpret(root_node)
        clock.tick()
        pygame.display.flip()
        
        
main()
